﻿using Syncfusion.SfDataGrid.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace DataGridDemo
{
    public class ViewModel : INotifyPropertyChanged
    {
        private bool isBusy ;

        /// <summary>
        /// Gets or Sets whether to show the busy indicator.
        /// </summary>
        public bool IsBusy
        {
            get { return isBusy; }
            set { isBusy = value; RaisePropertyChanged("IsBusy"); }
        }
        private IncrementalList<OrderInfo> _incrementalItemsSource;
        public IncrementalList<OrderInfo> IncrementalItemsSource
        {
            get { return _incrementalItemsSource; }
            set { _incrementalItemsSource = value; }
        }


        public ViewModel()
        {
            IncrementalItemsSource = new IncrementalList<OrderInfo>(LoadMoreItems) { MaxItemsCount = 1000 };
        }

        /// <summary>
        /// Method to load items which assigned to the action of IncrementalList
        /// </summary>
        /// <param name="count"></param>
        /// <param name="baseIndex"></param>
        async void LoadMoreItems(uint count, int baseIndex)
        {
            IsBusy = true;
            await Task.Delay(2000);
            var _orders = GenerateOrders();
            var list = _orders.Skip(baseIndex).Take(20).ToList();
            IncrementalItemsSource.LoadItems(list);
            IsBusy = false;
        }

        private ObservableCollection<OrderInfo> GenerateOrders()
        {
            var _orders = new ObservableCollection<OrderInfo>();
            _orders.Add(new OrderInfo(1001, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1002, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1003, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1004, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1005, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1006, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1007, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1008, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1009, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1010, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1011, "Maria Lincoln", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1012, "Thomas Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1013, "Thomas Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1014, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1015, "Christina Elizabeth", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1016, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1017, "Laurence Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1018, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1019, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1020, "Elizabeth Frédérique", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1021, "Maria Lebihan", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1022, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1023, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1024, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1025, "Christina Martin", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1026, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1027, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1028, "Martin Ana", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1029, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1030, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1031, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1032, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1033, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1034, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1035, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1036, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1037, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1038, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1039, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1040, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1041, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1042, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1043, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1044, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1045, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1046, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1047, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1048, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1049, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1050, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1051, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1052, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1053, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1054, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1055, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1056, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1057, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1058, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1059, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1060, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1061, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1062, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1063, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1064, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1065, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1066, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1067, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1068, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1069, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1070, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1071, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1072, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1073, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1074, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1075, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1076, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1077, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1078, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1079, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1080, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1081, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1082, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1083, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1084, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1085, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1086, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1087, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1088, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1089, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1090, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            _orders.Add(new OrderInfo(1091, "Maria Anders", "Germany", "ALFKI", "Berlin"));
            _orders.Add(new OrderInfo(1092, "Ana Trujilo", "Mexico", "ANATR", "México D.F."));
            _orders.Add(new OrderInfo(1093, "Antonio Moreno", "Mexico", "ANTON", "México D.F."));
            _orders.Add(new OrderInfo(1094, "Thomas Hardy", "UK", "AROUT", "London"));
            _orders.Add(new OrderInfo(1095, "Christina Berglund", "Sweden", "BERGS", "Luleå"));
            _orders.Add(new OrderInfo(1096, "Hanna Moos", "Germany", "BLAUS", "Mannheim"));
            _orders.Add(new OrderInfo(1097, "Frédérique Citeaux", "France", "BLONP", "Strasbourg"));
            _orders.Add(new OrderInfo(1098, "Martin Sommer", "Spain", "BOLID", "Madrid"));
            _orders.Add(new OrderInfo(1099, "Laurence Lebihan", "France", "BONAP", "Marseille"));
            _orders.Add(new OrderInfo(1100, "Elizabeth Lincoln", "Canada", "BOTTM", "Tsawassen"));

            return _orders;
        }
        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
